Page MenuHomePhabricator

Wikimedia Technical Conference 2018 Session - Architecting core: concepts
Closed, ResolvedPublic

Description

Session Themes and Topics

  • Theme: Architecting our code for change and sustainability
  • Topic: Definition of Core, how code fits together, architecture, code encapsulation, FE/BE separation, extension interface

Session Leader

  • Tim Starling

Facilitator

  • Greg Grossmeier

Description

In this session we will discuss what concepts and operations should be modeled in MediaWiki, what are the nouns and verbs that MediaWiki understands? This will help us better define components within the code base, interfaces for extensions, as well as APIs for interacting with clients.
Some concepts are obvious like “pages” and “edits”, but some concepts which are currently emulated by extensions may be helpful to introduce into MediaWiki proper, such as “workflows”, “drafts”, or “assessments”. Also, refining our definition and understanding of established concepts could be helpful, for instance to establish whether any curatable object on the wiki should be considered a “page”.

Questions to answer during this session

QuestionSignificance: Why is this question important? What is blocked by it remaining unanswered?
Which concepts are essential to MediaWiki functionality?Why is this question important? What is blocked by it remaining unanswered? Establish a shared understanding what the “core” of MediaWiki is about, what functionality the “platform” should provide.
Which additional concepts are widely used (via gadgets, extensions, bots, etc) , but not explicitly modeled by MediaWiki? Which of these should be modeled in MediaWiki?This allows us to develop a plan to remove technical debt, inconsistencies and overhead caused by the need to somehow glue concepts into MediaWiki which it doesn’t support. Paving the cow paths reduces friction, replacing hacks with well defined concepts makes the code more maintainable.
Conversely, what functionality currently in core should be factored out into an extension? What extension points would be necessary to do this?This ties this session into the discussions about modularization and extension interfaces. Moving code for optional functionality into extensions makes core more easy to maintain.
What are the criteria for deciding whether a concept should be modeled in core, and if it is supported, to what extent it is fleshed out, or left as a mere extension point.Having a decision matrix template for this question will allow us to make decisions about what concepts should be in core more quickly, and with more confidence.

Facilitator and Scribe notes

https://docs.google.com/document/d/1jY-MrwrGLKqX922obwFoYj0C_JdxFCH9Vtf4w4gHr-8/edit

Facilitator reminders

Session Structure

  • Define session scope, clarify desired outcomes, present agenda
  • Discuss Focus Areas
    • Discuss and Adjust. ''Note that we are not trying to come to a final agreement, we are just prioritizing and assigning responsibilities!''
    • For each proposition [add etherpad link here]
      • Decides whether there is (mostly) agreement or disagreement and the proposition(s).
      • Decide whether there is more need for discussion on the topic, and how urgent or important that is.
      • Identify any open questions that need answering from others, and from who (product, ops, etc)
      • Decides who will drive the further discussion/decision process (ie: a four month deadline)
  • Discuss additional strategy questions [add etherpad link here]. For each question:
    • Decide whether it is considered important.
    • Discuss who should answer it.
    • Decide who will follow up on it.
  • Wrap up

Session Leaders please:

  • Add more details to this task description.
  • Coordinate any pre-event discussions (here on Phab, IRC, email, hangout, etc).
  • Outline the plan for discussing this topic at the event.
  • Optionally, include what it will not try to solve.
  • Update this task with summaries of any pre-event discussions.
  • Include ways for people not attending to be involved in discussions before the event and afterwards.

Post-event Summary:

  • ...

Action items:

  • ...

Event Timeline

debt created this task.Oct 2 2018, 11:02 PM
Restricted Application added a subscriber: Aklapper. · View Herald TranscriptOct 2 2018, 11:02 PM
kchapman renamed this task from Wikimedia Technical Conference 2018 Session - Core: extension migration to Wikimedia Technical Conference 2018 Session - Architecting core: extension migration.Oct 3 2018, 2:24 AM
debt updated the task description. (Show Details)Oct 4 2018, 11:37 PM
Fjalapeno renamed this task from Wikimedia Technical Conference 2018 Session - Architecting core: extension migration to Wikimedia Technical Conference 2018 Session - Architecting core: concepts.Oct 8 2018, 4:42 PM
debt updated the task description. (Show Details)Oct 10 2018, 1:57 PM
debt assigned this task to tstarling.Oct 16 2018, 10:27 PM
debt updated the task description. (Show Details)
debt updated the task description. (Show Details)Oct 17 2018, 5:00 PM
debt added a subscriber: greg.
debt updated the task description. (Show Details)Oct 17 2018, 9:23 PM
Quiddity updated the task description. (Show Details)Oct 20 2018, 1:03 AM
Tgr added a subscriber: Tgr.Oct 21 2018, 11:50 PM
tstarling added a comment.EditedOct 25 2018, 7:24 AM

Existing examples:

  • Page
    • Has revisions
    • Must it have a title?
  • Actions: edit/view, rollback/undo, delete/undelete, move

Examples of missing core concepts:

  • Page type: file, category, etc. Have subclasses but no way to get the type of a page, or list or add types.
  • FlaggedRevs requirement:
    • published timestamp
  • CentralAuth requirement:
    • User store/repo?
    • Global user?

Questions:

  • Which missing/incomplete concepts are tech debt, support existing use cases poorly?
  • Which missing/incomplete concepts are requirements for planned features?
tstarling updated the task description. (Show Details)Oct 25 2018, 7:25 AM

Hello! We are starting to ramp up on session creation for the 2019 Wikimedia Technical Conference. If there is no longer anything remaining to do here please close this task to avoid confusion.

daniel closed this task as Resolved.Sep 12 2019, 10:28 AM